<?php
/**
 * Extension Install File
 * Does the stuff for the specific extensions
 *
 * @package         Sourcerer
 * @version         3.3.0
 *
 * @author          Peter van Westen <peter@nonumber.nl>
 * @link            http://www.nonumber.nl
 * @copyright       Copyright © 2012 NoNumber All Rights Reserved
 * @license         http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

defined('_JEXEC') or die;

$name = 'Sourcerer';
$alias = 'sourcerer';
$ext = $name . ' (system plugin & editor button plugin)';

// SYSTEM PLUGIN
$states[] = installExtension($states, $alias, 'System - ' . $name, 'plugin');

// EDITOR BUTTON PLUGIN
$states[] = installExtension($states, $alias, 'Editor Button - ' . $name, 'plugin', array('folder' => 'editors-xtd'));

/* >>> [J1] >>> */
// Stuff to do after installation / update
function afterInstall_j1(&$db)
{
	// REMOVE MODULE
	// Rename old module name
	$query = "UPDATE `#__modules`
		SET `title` = 'Sourcerer Module'
		WHERE `title` = 'Sourcerer! Module'";
	$db->setQuery($query);
	$db->query();

	// Change old Sourcerer modules to normal custom HTML modules (because Sourcerer modules won't work anymore!)
	$query = "UPDATE `#__modules`
		SET `module` = 'mod_custom',
		`content` = replace( replace( `params`, 'text=', '' ), '" . '\\\\n' . "', '" . '\\n' . "' ),
		`params` = ''
		WHERE `module` = 'mod_sourcerer'";
	$db->setQuery($query);
	$db->query();

	// Make sure we delete the folders
	if (is_dir(JPATH_SITE . '/modules/mod_sourcerer')) {
		JFolder::delete(JPATH_SITE . '/modules/mod_sourcerer');
	}
	// Delete module language files
	$file_orginal_lang_path = JPATH_SITE . '/language';
	$dir_folders = JFolder::folders($file_orginal_lang_path);
	foreach ($dir_folders as $lang_name) {
		$file_lang_file = $file_orginal_lang_path . '/' . $lang_name . '/' . $lang_name . '.mod_sourcerer.ini';
		if (is_file($file_lang_file)) {
			JFile::delete($file_lang_file);
		}
	}

	// Rename old plugin name
	$query = "UPDATE `#__plugins`
		SET `name` = 'System - Sourcerer'
		WHERE `name` = 'System - Sourcerer!'";
	$db->setQuery($query);
	$db->query();

	// Rename old plugin name
	$query = "UPDATE `#__plugins`
		SET `name` = 'Editor Button - Sourcerer'
		WHERE `name` = 'Editor Button - Sourcerer!'";
	$db->setQuery($query);
	$db->query();
}
/* <<< [J1] <<< */
